# utils.py

import globals as glob
import data

#########################################
def ChangeRoom( collidedToExitGateId ):
    exitTriggers = glob.roomParameters2[glob.roomIndex][2]
    itemsPerTrigger = 4
    for i in range(len(exitTriggers)//itemsPerTrigger):
        index = i*itemsPerTrigger
        if(exitTriggers[index] == collidedToExitGateId):
            
            ### Change room
            
            glob.roomIndex = exitTriggers[index+1]
            newX = exitTriggers[index+2]
            newY = exitTriggers[index+3]
            
            # Set hero pos
            if(newX!=-999):
                glob.heroGob.wx = newX
            if(newY!=-999):
                glob.heroGob.wy = newY
                
             # Reset room
            ResetRoom(glob.roomIndex)

            # Change music
            newBgMusic = "rap2h.raw"
            if(glob.roomIndex==6):
                newBgMusic = "danger.raw"
            if(glob.currentBgMusic!=newBgMusic):
                glob.currentBgMusic=newBgMusic
                print("play:", glob.currentBgMusic)
                
                # Stop music after a while
                #if(glob.currentBgMusic =="danger.raw"):
                #    glob.timedEventList.append([glob.currentFrameTime + 9000, glob.TIMED_EVENT_STOP_MUSIC])
                #    glob.timedEventList.sort(key=glob.TimedEventSortFunc)
                
                if(glob.isEmulator==False):
                    glob.sound.play_from_sd(glob.currentBgMusic)
                        
            break

#########################################
def ResetRoom(roomIndex):
    
    #print("ResetRoom. roomIndex", roomIndex)
    
    tileParameters = glob.roomParameters2[roomIndex][1]
    sprites = glob.roomParameters2[roomIndex][3]
    
    # Update tilemap
    ChangeTilemap(data.worldMaps[roomIndex], tileParameters)
    glob.test += 1
    
    # Uninit all gobs
    for i in range(glob.ENEMIES_MAX_COUNT):
        enemy = glob.all_enemies_list[i]
        enemy.id = -1
        enemy.wx = -999
        enemy.rect.x = -999
        enemy.active = False

    ActivateEnemiesbyTrigger(0xff, sprites)
    

#########################################
def ActivateEnemiesbyTrigger(triggerId, sprites):
    
    itemsPerSprite = 8
    for i in range(len(sprites)//itemsPerSprite):
        #glob.roomParameters[roomIndex][0] is the room name
        #gobIndex=i
        index = i*itemsPerSprite
        spriteFramesAndOffsets = sprites[index]
        
        spriteBytes = sprites[index+7]
        spriteId = spriteBytes[0]
        
        # If this is an already collected coin, skip and continue to the next item
        #print("collectedItems",glob.collectedItems)
        isAlreadyCollected = False
        for j in glob.collectedItems:
            itemTuple = (glob.roomIndex, spriteId)
            if(j == itemTuple):
                #print("collected")
                isAlreadyCollected = True
        if(isAlreadyCollected):
            continue
        
        #spriteMemberdata = spriteParams[3]
        spriteTriggerId = spriteBytes[1]
        
        # Check the trigger id of the gob
        if(spriteTriggerId==triggerId):
            # find the id in the current gob list 
            # print("reset or create this gob. id=",spriteId)
            foundGobId = -1
            enemyGob = None
            for j in range(glob.ENEMIES_MAX_COUNT):
                enemyGob2 = glob.all_enemies_list[j]
                if(enemyGob2.id == spriteId):
                    # Found gob with the same id. Replace this gob
                    enemyGob = enemyGob2
                    break
                elif(enemyGob2.id == -1):
                    # Found unused Gob. Use it now.
                    enemyGob = enemyGob2
                    break
                
            # Reuse this gob
            enemyGob.active = True
            enemyGob.id = spriteId
            spriteFrames = []
            spriteOffsets = []
            for frameNum in range(len(spriteFramesAndOffsets)//2):
                spriteFrames.append( spriteFramesAndOffsets[frameNum*2] )
                spriteOffsets.append( spriteFramesAndOffsets[(frameNum*2)+1] )
            enemyGob.frames = spriteFrames
            enemyGob.frameOffsets = spriteOffsets
            enemyGob.wx = sprites[index+1]
            enemyGob.wy = sprites[index+2]
            enemyGob.vx = spriteBytes[2]
            enemyGob.vy = spriteBytes[3]
            enemyGob.animDur = spriteBytes[4]
            enemyGob.dir = spriteBytes[5]
            enemyGob.moveDelay = spriteBytes[6]
            enemyGob.bounceLimits[0] = sprites[index+3]
            enemyGob.bounceLimits[1] = sprites[index+4]
            enemyGob.bounceLimits[2] = sprites[index+5]
            enemyGob.bounceLimits[3] = sprites[index+6] 
            enemyGob.bounceType = spriteBytes[7]
            enemyGob.hmirror = spriteBytes[8]
            enemyGob.vmirror = spriteBytes[9]
            enemyGob.isCoin = spriteBytes[10]
            enemyGob.currentAnimFrameNum = 0;
            enemyGob.UpdateImage()
            enemyGob.animDurCounter = enemyGob.animDur
            enemyGob.moveDelayCounter = 0
       
       
#########################################
def ChangeTilemap(tilemap, tileParameters):
    
    # print("tileParameters=", tileParameters)

    # Copy tilemap data
    for i in range(len(tilemap)):  #(18*14): # 252
        data.ramMapPixels[i] = tilemap[i]
        #print("data.ramMapPixels[i]", hex(data.ramMapPixels[i]),"i",i)

    # Set tile attributes and bitmaps
    tileParameterCount = 3
    for ii in range(len(tileParameters)//tileParameterCount):
        i = ii*tileParameterCount
        tileId = tileParameters[i]
        glob.tileAttributeArray[tileId] = tileParameters[i+2]
        glob.tilemap.set_tile(tileId, 8, 8, tileParameters[i+1])
        #print("tileParameters[i+1]", tileParameters[i+1],"i",i)
        
        # Handle gate unlocking
        if(glob.tileAttributeArray[tileId] & glob.TILE_FLAG_LOCKED_GATE):
            # Found locked gate tile.
            if(glob.goldCount>=4):
                # unlock
                glob.tileAttributeArray[tileId] = glob.TILE_FLAG_EXIT_GATE
                glob.tilemap.set_tile(tileId, 8, 8, data.backgroundSurf5)
            
#########################################
def RemoveTriggerTileAttribute(triggerId):
    
    # 
    tileParameters = glob.roomParameters2[glob.roomIndex][1]
    tileParameterCount = 3
    for ii in range(len(tileParameters)//tileParameterCount):
        i = ii*tileParameterCount
        tileId = tileParameters[i]
        if(tileId == triggerId):
            # Reset the TILE_FLAG_TRIGGER flag to 0
            attributes = tileParameters[i+2] & glob.TILE_MASK_TRIGGER
            glob.tileAttributeArray[tileId] = attributes

